#!/bin/bash

# ------------------------------------------------

sources=(
    '/etc/gentool/config.sh'
    '/opt/gentool/lib/fns.sh'
    '/opt/gentool/lib/sync.sh'
    '/opt/bashfun/misc.sh'
    '/opt/bashfun/disk.sh'
    '/opt/bashfun/rsync.sh'
)
for s in ${sources[@]}
do
    source $s
done

# ------------------------------------------------

is_pretending='false'

for o in $@
do
    if [ "$o" = '--pretend' ]
    then
        echo 'pretending...'
        is_pretending='true'
        root_backup_policy=`makePretend "$root_backup_policy"`
        boot_backup_policy=`makePretend "$boot_backup_policy"`
        empty_dir_policy=`makePretend "$empty_dir_policy"`
    fi
    if [ "$o" != "`echo $o | sed s/--dest=//g`" ]
    then
        dest=`echo "$o" | sed s/--dest=//g`
        dest=`stripEndSlash "$dest"`
    fi
done

if [ "" = "$dest" ]
then
    dest="$gentool_mirror_mount_point"
fi

echo 'destination is ['${dest}']'
root_dest=${dest}'/'
boot_dest=${dest}'/boot/'

gentool mount
if [ 'true' = "$is_pretending" ]
then
    echo '$root_backup_policy: '$root_backup_policy
fi
eval rsync '/*' $root_dest "$root_backup_policy"
echo
rebuildFilesystem $root_dest
echo
copySpecialFiles $root_dest
echo
if [ 'true' = $is_pretending ]
then
    echo '$boot_backup_policy: '$boot_backup_policy
fi
eval rsync '/boot/*' $boot_dest  "$boot_backup_policy"
echo
gentool umount

exit 0
